﻿Imports System
Imports System.Collections.Generic
Imports System.Collections.Specialized
Imports System.IO
Imports System.Linq
Imports System.Net
Imports System.Text
Imports System.Threading.Tasks

Public Class APIClient

	Public Shared Function UploadFilesToRemoteUrl(url As String, simpleParams As NameValueCollection, fileParams As NameValueCollection) As String
        ' Strings to be used as boundries for the multipart request
        Dim boundary As String = "----------------------------" & DateTime.Now.Ticks.ToString("x")
        Dim boundarybytes As Byte() = System.Text.Encoding.ASCII.GetBytes(vbCr & vbLf & "--" & boundary & vbCr & vbLf)
        Dim lastBoundarybytes As Byte() = System.Text.Encoding.ASCII.GetBytes(vbCr & vbLf & "--" & boundary & "--")

        ' Form field multipart header template
        Dim formdataTemplate As String = vbCr & vbLf & "--" & boundary & vbCr & vbLf & "Content-Disposition: form-data; name=""{0}"";" & vbCr & vbLf & vbCr & vbLf & "{1}"

        ' File field multipart header template
        Dim headerTemplate As String = "Content-Disposition: form-data; name=""{0}"";filename=""{1}""" & vbCr & vbLf & "Content-Type: application/octet-stream" & vbCr & vbLf & vbCr & vbLf

        ' Memory stream to buffer the data to be sent over http connection
        Dim memStream As Stream = New System.IO.MemoryStream()

        ' Create the multipart web request to be sent
        Dim httpWebRequest As HttpWebRequest = DirectCast(WebRequest.Create(url), HttpWebRequest)

        ' Set the various headers for the http request
        httpWebRequest.ContentType = "multipart/form-data; boundary=" & boundary
        httpWebRequest.Method = "POST"
        httpWebRequest.KeepAlive = True
        httpWebRequest.Credentials = System.Net.CredentialCache.DefaultCredentials

        ' Fix for the issue in .Net library
        System.Net.ServicePointManager.Expect100Continue = False

        ' Append the non-file parameters to the memory stream
        For Each key As String In simpleParams.Keys
            Dim formitem As String = String.Format(formdataTemplate, key, simpleParams(key))
            Dim formitembytes As Byte() = System.Text.Encoding.UTF8.GetBytes(formitem)
            memStream.Write(formitembytes, 0, formitembytes.Length)
        Next

        If fileParams.Keys.Count > 0 Then
            memStream.Write(boundarybytes, 0, boundarybytes.Length)

            ' Append the file parameters
            Dim fileParamIndex As Integer = 0
            For Each key As String In fileParams.Keys
                ' Header for the File part of form data
                Dim header As String = String.Format(headerTemplate, key, fileParams(key))
                Dim headerbytes As Byte() = System.Text.Encoding.UTF8.GetBytes(header)

                memStream.Write(headerbytes, 0, headerbytes.Length)

                ' Dump the file content to the memory stream
                Dim fileStream As New FileStream(fileParams(key), FileMode.Open, FileAccess.Read)
                Dim buffer As Byte() = New Byte(1023) {}

                Dim bytesRead As Integer = 0

                While (InlineAssignHelper(bytesRead, fileStream.Read(buffer, 0, buffer.Length))) <> 0
                    memStream.Write(buffer, 0, bytesRead)
                End While

                fileStream.Close()

                ' If there are more files to be sent, write the intermediate boundry
                If System.Math.Max(System.Threading.Interlocked.Increment(fileParamIndex), fileParamIndex - 1) < (fileParams.Count - 1) Then
                    memStream.Write(boundarybytes, 0, boundarybytes.Length)
                End If
            Next
        End If

        ' Write the last part of POST request
        memStream.Write(lastBoundarybytes, 0, lastBoundarybytes.Length)

        ' Set the content length for the POST request
        httpWebRequest.ContentLength = memStream.Length

        ' Reposition the memory stream pointer to start reading from the begining
        memStream.Position = 0

        ' Get the memmory stream into a buffer to be sent over http
        Dim tempBuffer As Byte() = New Byte(memStream.Length - 1) {}
        memStream.Read(tempBuffer, 0, tempBuffer.Length)
        memStream.Close()

        ' Send the data to server
        Dim requestStream As Stream = httpWebRequest.GetRequestStream()
        requestStream.Write(tempBuffer, 0, tempBuffer.Length)
        requestStream.Close()

        ' Get the response from Server
        Dim webResponse2 As WebResponse = httpWebRequest.GetResponse()
        Dim stream2 As Stream = webResponse2.GetResponseStream()
        Dim reader2 As New StreamReader(stream2)
        Dim str As String = reader2.ReadToEnd()
        webResponse2.Close()

        httpWebRequest = Nothing
        webResponse2 = Nothing

        Return str
    End Function

	Private Shared Function InlineAssignHelper(Of T)(ByRef target As T, value As T) As T
		target = value
		Return value
	End Function

End Class

